Wit 2.5.0-beta 发布,不再支持 Java 7

zqq90
 zqq90
发布于 2018年01月22日
收藏 4

Febit Wit 是一个 Java 平台下的模板引擎,语法类似 JavaScript,支持自定义函数,全局变量,Lambda 表达式,核心模块轻巧,无第三方依赖,采用BSD开源协议。

2.5.0-beta 更新内容如下:

  • 最重要的: 现在至少需要 Java 8 以上, 不再支持 Java 7 及以下版本

  • 修正: 仅当表达式元素不可变(immutable)时才执行优化

  • 废弃: KeyValuesUtil 不再推荐使用, 会尽快被移除, 请使用 Vars.of(..) 代替

  • 变更: 请使用 getters 访问 Template 的属性, 不再提供相关的字段的直接访问

  • 删除: 删除已废弃的 KeyValues, 已由 Vars 代替

  • 删除: 删除已废弃的 CFG

  • 删除: 不再支持重定向表达式, 因其在优先级上不符合预期, 但重定向句柄依旧保留

  • 删除: 移除不再需要的 api: GlobalManager#commit(), Engine#init(), 如有调用直接删除即可

  • 删除: 移除 RegistModeResolver, 可以通过覆盖 Resolver#register(..) 实现同等效果

  • 新增: 新增 GlobalManager#setConstMethod(...), 方便使用 lambda 和函数引用直接添加常量函数

  • 新增: 新增 codeFirst 的 codeStringLoader, 向准脚本引擎迈进

  • 新增: 支持更多 Number 类型的基本运算

  • 其他: 一(大)些(量)细节调整及删减

值得一(卖)提(弄)的是, 这个版本只有 306.3kB, 比较遗憾的是最终没能缩减到 300kB 以下, 说出来你们可能不信, 我真的是有强迫症, 只不过代码强迫症可能更严重一些, 一些该有的东西还是必须要有的, 否做把只是为了优化性能的 asm 相关模块删掉妥妥的能再减少 20kB 以上.

接下来, 着重介绍一下 codeStringLoader:

codeStringLoader 实际上只是在配置层面将 StringLoader 的 codeFirst 设置为 true, 这一特性很早就已经支持了, 只是这次将其配置到了默认配置中, 示例:

之前我们得到一个字符串模板需要:

Template t = engine.getTemplate("string:<% echo \"Hello Wit!\"; %>");

但是现在, 也可以更简单些:

Template t = engine.getTemplate("code: echo \"Hello Wit!\" ");

这对于把 wit 当做脚本用途的场景,会相当方便, 例如: 

支持脚本的 Hive 自定义函数

这里就是用到了这种方式

本站文章除注明转载外,均为本站原创或编译。欢迎任何形式的转载,但请务必注明出处,尊重他人劳动共创开源社区。
转载请注明:文章转载自 开源中国社区 [http://www.oschina.net]
本文标题:Wit 2.5.0-beta 发布,不再支持 Java 7
加载中

最新评论(1

Andyfoo
Andyfoo
支持
返回顶部
顶部